////////////////////////////////////////////// 
//        RemoteXY include library          // 
////////////////////////////////////////////// 

// определение режима соединения и подключение библиотеки RemoteXY  
#define REMOTEXY_MODE__HARDSERIAL

#include <RemoteXY.h> 

// настройки соединения  
#define REMOTEXY_SERIAL Serial1 
#define REMOTEXY_SERIAL_SPEED 9600 

// конфигурация интерфейса   
#pragma pack(push, 1) 
uint8_t RemoteXY_CONF[] = 
  { 0,3,27,0,6,0,1,65,15,0
  ,10,63,90,2,129,0,7,1,51,9
  ,9,77,111,111,100,32,76,97,109,112
  ,0 }; 
   
// структура определяет все переменные вашего интерфейса управления  
struct { 

    // output variable
  uint8_t led_1_r; // =0..255 яркость красного цвета индикатора 
  uint8_t led_1_g; // =0..255 яркость зеленого цвета индикатора 
  uint8_t led_1_b; // =0..255 яркость синего цвета индикатора 

    // other variable
  uint8_t connect_flag;  // =1 if wire connected, else =0 

} RemoteXY; 
#pragma pack(pop) 

///////////////////////////////////////////// 
//           END RemoteXY include          // 
///////////////////////////////////////////// 
uint8_t i=1; //эта переменная будет определять, какой цвет должен изменяться

void setup()  
{ 
  RemoteXY_Init ();  

} 

void loop()  
{  
RemoteXY_Handler (); 
//все действия будут происходить в главном цикле, поскольку передача данных на смартфон осуществляется в обработчике RemoteXY_Handler() который находится в функции loop()

if (i==1) { //при i==1 увеличивается яркость зеленого цвета
RemoteXY.led_1_g++; //это условие сработает 255 раз
  if (RemoteXY.led_1_g==255) {i++;} //когда яркость зеленого цвета будем максималь-ной, увеличиваем i на 1 и это условие не будет срабатывать, пока i вновь не станет равно 1 
}

if (i==2) { //и передаем эстафету следующему условию
RemoteXY.led_1_r--; //здесь уменьшаем яркость красного цвета
  if (RemoteXY.led_1_r==0) {i=i+1;} //и снова передаем эстафету
}

if (i==3) {
RemoteXY.led_1_b++; //увеличиваем яркость синего
  if (RemoteXY.led_1_b==255) {i=i+1;}
}

if (i==4) {
RemoteXY.led_1_g--; //уменьшаем яркость зеленого
  if (RemoteXY.led_1_g==0) {i=i+1;}
}

if (i==5) {
RemoteXY.led_1_r++; //увеличиваем яркость красного
  if (RemoteXY.led_1_r==255) {i=i+1;}
}

if (i==6) {
RemoteXY.led_1_b--; //уменьшаем яркость синего
  if (RemoteXY.led_1_b==0) {i=i+1;}
} //цикл перебора цветов завершен

//выводим цвета на трехцветный светодиод через ШИМ

analogWrite(13, RemoteXY.led_1_r); 
analogWrite(12, RemoteXY.led_1_g);
analogWrite(11, RemoteXY.led_1_b);

if (i==7) {i=1;} //поскольку цикл завершен, то сбрасываем i к первоначальному значе-нию, то есть к 1
delay(10); //задержку такого рода ставить не рекомендуется, но без нее перебор цветов слишком быстрый. К тому же такая короткая пауза не препятствует связи контроллера со смартфоном.
}

