////////////////////////////////////////////// 
//        RemoteXY include library          // 
////////////////////////////////////////////// 

#define REMOTEXY_MODE__HARDSERIAL

#include <RemoteXY.h> 

// настройки соединения  
#define REMOTEXY_SERIAL Serial1 
#define REMOTEXY_SERIAL_SPEED 9600 
 
#pragma pack(push, 1) 
uint8_t RemoteXY_CONF[] = 
  { 1,11,137,0,6,5,1,1,1,8
  ,12,48,13,2,208,161,208,179,208,181
  ,208,189,208,181,209,128,208,184,209,128
  ,208,190,208,178,208,176,209,130,209,140
  ,32,208,191,208,176,209,128,208,190,208
  ,187,209,140,0,67,1,10,41,43,7
  ,3,11,129,0,8,4,48,5,0,208
  ,147,208,181,208,189,208,181,209,128,208
  ,176,209,130,208,190,209,128,32,208,191
  ,208,176,209,128,208,190,208,187,208,181
  ,208,185,0,129,0,8,29,48,5,0
  ,208,146,208,176,209,136,32,208,189,208
  ,190,208,178,209,139,208,185,32,208,191
  ,208,176,209,128,208,190,208,187,209,140
  ,0 }; 
   
struct { 

    // input variable
  uint8_t button_1; // кнопка будет запускать генерацию

    // output variable
  char text_1[11];  // в этой строке пароль будет передан в смартфон 
  //обратите внимание, что здесь изменить длину строки нельзя
    // other variable
  uint8_t connect_flag;  // =1 if wire connected, else =0 

} RemoteXY; 
#pragma pack(pop)  

///////////////////////////////////////////// 
//           END RemoteXY include          // 
///////////////////////////////////////////// 
char pass[11]; //в этом массиве символов будет храниться сгенерированный пароль до передачи его в смартфон

void setup()  
{ 
  RemoteXY_Init ();  
} 

void loop()  
{  
  RemoteXY_Handler (); 

if (RemoteXY.button_1==1){//если нажата кнопка "сгенерировать пароль", то начинаем генерировать пароль 
 randomSeed(millis()); //инициализация генератора случайных чисел
 for  (int i=0; i<=9; i++){ //в нашем пароле 10 символов, начинаем генерировать по 1 символу. Массивы нумеруются с 0, поэтому начальное значение i=0.
  pass[i]=random(48, 122); //присваиваем очередному элtменту массива pass случайное значение из таблицы ascii, я использую с 44 по 122 символы.
//в функции random указано, с какого и по какой символы таблицы ascii использовать при генерации
 }
 
RemoteXY.button_1=0; //обнуляем значение кнопки, что бы был сгенерирован один пароль
//иначе генерация будет продолжаться, пока будет нажата кнопка «сгенерировать пароль»
  }

strcpy(RemoteXY.text_1, pass); //передаем сгенерированный пароль в поле структуры text_1   

}

